#include <vector>
#include <iostream>

namespace a {

struct droga {
  int cel;
  int waga, okres, start_okresu, czas_bezpieczny;
};

std::vector<droga> bazy[50001];

int il_baz;
int drogi;

int d[50001];
const int max_d = 2000000000;

const int max_n=50001;

int heapsize=0;
int a[max_n];
int index[max_n];

void zamien(int &x, int &y)
{
  int tym=x; x=y; y=tym;
  tym=index[x]; index[x]=index[y]; index[y]=tym;
}

int min(int x, int y){ return x<y?x : y; }

void heapify(int i)
{
  int l,r,small;
  l=2*i;
  r=2*i+1;
  if ((l<=heapsize) && (d[a[l]]<d[a[i]]))
    small=l; else small=i;
  if((r<=heapsize)&&(d[a[r]]<d[a[small]]))
    small=r;
  if(small !=i)
    {
      index[a[i]]=small;
      index[a[small]]=i;
      zamien(a[i],a[small]);
      heapify(small);
    }
}

void heap_insert(int x)
{
  int i;
  heapsize++;
  i=heapsize;
  while((i>1)&&(d[a[i/2]]>d[x]))
    {
      a[i]=a[i/2];
      index[a[i]]=i;
      i= i/2;
   }
  a[i]=x;
  index[x]=i;

}

void heap_dec(int x)
{
    int i=index[x];
    //    if(d[a[i]]>d[x])
      {
	while((i>1)&&(d[a[i/2]]>d[x]))
	  {
	    a[i]=a[i/2];
	    index[a[i]]=i;
	    i=i/2;
	  }
	a[i]=x;
	index[x]=i;
      }
}

bool extract(int &x)
  {
    if(heapsize<1)return 0;
    else
      {
	x=a[1];
	a[1]=a[heapsize];
	index[a[1]]=1;

	heapsize--;
	heapify(1);
	return 1;
      }
}



void init_data() {
  for (int i=1; i<=il_baz; ++i) {
    d[i]=max_d;
    heap_insert(i);
  }
  d[1]=0;
  heap_dec(1);
}

//zwraca true jesli poprawiono wage
void relax(int x, droga& dr) {
  int nowa_waga, m;
  // std::cout << "Relax x=" <<x <<" dr.cel=" << dr.cel << std::endl;
  if (dr.okres == 0 || (m=((d[x] - dr.start_okresu) % dr.okres))<dr.czas_bezpieczny)
    nowa_waga = d[x] + dr.waga ;
  else {
    nowa_waga =  d[x] + dr.waga + dr.okres - m;
  }
  if (d[dr.cel] > nowa_waga) {
    d[dr.cel] = nowa_waga;
    heap_dec(dr.cel);
  }
}



void read() {
  std::cin >> il_baz >> drogi;
  for (int i = 0; i < drogi; ++i) {
    int z;
    std::cin >> z;
    bazy[z].push_back(droga());
    droga& d = *(bazy[z].end()-1);
    scanf("%d%d%d%d%d",d.cel,d.waga,d.okres,d.start_okresu,d.czas_bezpieczny);
    //    std::cin >> d.cel >> d.waga >> d.okres >> d.start_okresu >> d.czas_bezpieczny;
  }
}

int main(){
  int zest;
  std::cin >> zest;
  while (zest) {
    read();
    init_data();
    int x;
    while(extract(x))
    {
      //for (int y = bazy[x].size()-1; y >= 0; --y)
      //relax(x, bazy[x][y]);
      for (std::vector<droga>::iterator i = bazy[x].begin();
	   i != bazy[x].end();
	   ++i)
	relax(x, *i);
    }
    if (d[il_baz]==max_d)
      std::cout << "NIE\n";
    else
      std::cout << d[il_baz] << std::endl;

    //    for(int i=0; i<=il_baz; i++)
    //  std::cout << d[i] << std::endl;
    
    for (int i = 1; i <= il_baz; ++i)
      bazy[i].clear();
    --zest;
    heapsize=0;
  }

  return 0;
}


}
int main(){return a::main();}
